config/routes.rb
Moocchat::Application.routes.draw do
  mount JasmineRails::Engine => '/specs' if defined?(JasmineRails)

  resources :conditions
  resources :activity_schemas
  resources :questions
  resources :templates

  root :to => 'tasks#static', :as => 'root'

  get '/group_formation_times/:activity_schema_id/:condition_id' =>
    'waiting_rooms#group_formation_times'

  get '/seconds_to_next_group_formation/:activity_schema_id/' =>
    'waiting_rooms#seconds_to_next_group_formation'

  get '/get_current_timestamp_utc/' =>
    'waiting_rooms#get_current_timestamp_utc'

  match '/auth/:provider/callback', :to => 'sessions#try_login'
  get '/auth/failure', :to => 'sessions#login_failed'
  post '/logout', :to => 'sessions#destroy'

  post '/tasks/:learner_name/:activity_schema_id/:condition_id' => 'tasks#create', :as => 'task_create'
  post '/tasks' => 'tasks#create' # regular form posting
  get '/tasks/turk/:condition_id' => 'tasks#create_turk' # entry point for Turk workers

  post '/tasks/:id/force_continue', :to => 'tasks#force_continue', :as => 'task_force_continue'

  post '/tasks/:id/disconnect', :to => 'tasks#disconnect', :as => 'task_disconnect'

  post '/tasks/:id/heartbeat', :to => 'tasks#heartbeat', :as => 'task_heartbeat'

  get '/tasks/error', :to => 'tasks#error', :as => 'task_error'

  get '/tasks/:id', :to => 'tasks#welcome', :as => 'task_welcome'

  post '/tasks/:id/join_group', :to => 'tasks#join_group', :as => 'task_join_group'

  get '/tasks/:id/complete', :to => 'tasks#complete', :as => 'task_complete'

  get '/tasks/:id/page', :to => 'tasks#page', :as => 'task_page'

  post '/tasks/:id/collect_response', :to => 'tasks#collect_response', :as => 'task_collect_response'

  post '/tasks/:id/next_page', :to => 'tasks#next_page', :as => 'task_next_page'

  post '/tasks/:id/log', :to => 'tasks#log', :as => 'task_log_event'

  get "users/record_consent"
  get "users/check_consent"

  get '/reports/chatlog' => 'reports#chatlog'
  post '/reports/chatlog/show' => 'reports#chatlog_show'
  get '/reports/sessions' => 'reports#sessions'
  post '/reports/sessions/show' => 'reports#sessions_show'

end

app/models/task.rb
class Task < ActiveRecord::Base

  # Ties together a +Learner+, and +Condition+ into
  # a task that steps the learner through a sequence of pages.

  belongs_to :learner
  belongs_to :condition
  validates_associated :learner
  validates_associated :condition

  # In most experiments, at some point a +Task+ will be added to a
  # +WaitingRoom+, which collects learners and forms groups from them.
  belongs_to :waiting_room

  # The sequence state is tracked by an internal private class
  # +Task::Sequencer+, certain elements of which are exposed via
  # delegation as read-only attributes of this class.

  require_relative './task/task_sequencer'
  serialize :sequence_state, Sequencer

  serialize :turk_params, Hash

  # Tasks log interesting events to an +EventLog+.
  has_one :event_log	

  attr_accessible :condition, :learner, :completed, :original_chat_group, :chat_group, :sequence_state, :turk_params

  # Exception raised when learner tries to create task for an activity that
  # isn't open yet
  class ActivityNotOpenError < RuntimeError ; end
  # Exception raised when +learner_index+ is called but this task's learner
  # isn't in the specified chat group channel
  class LearnerNotInGroupError < RuntimeError ; end
  
  serialize :user_state, Hash

  # For testing purposes, an admin or "Test learner" can bypass the
  # timer on the welcome page and force group formation to happen RIGHT NOW.
  delegate :force_group_formation_now!, :to => :waiting_room

  # Create a new task from a hash that includes a +condition_id+,
  # +activity_schema_id+, and +learner_name+.
  #
  # +condition_id+ and +activity_schema_id+ must be the primary keys
  # of an existing valid +Condition+ and +ActivitySchema+ respectively.
  #
  # +learner_name+ is the learner's nym; if it doesn't exist, an instance
  # of +Learner+ will be created.
 
  def self.create_from_params(params)
    cond = params[:condition_id]
    if(cond.is_a?(Hash)) #suggested by github to handle collection select(which returns {:id => value} rather than value)
      cond = cond[:id]
    end
    condition = Condition.find  cond
    learner = Learner.find_or_create_by_name! params[:learner_name]

    raise ActivityNotOpenError unless condition.primary_activity_schema.enabled?
    
    @t = Task.create!(
      :condition => condition,
      :learner => learner,
      :completed => false,
      :original_chat_group => nil,
      :chat_group => nil,
      :sequence_state => Sequencer.new(:body_repeat_count => condition.body_repeat_count, :num_questions => condition.primary_activity_schema.num_questions),
      :turk_params => params[:turk_params]
      )
  end

  # The counter starts at 0 on the first page of the task and
  # counts by 1 as each new page is visited.
  delegate :counter, :to => :sequence_state

  # Which question from the +ActivitySchema+ is to be served next (0-based)
  delegate :question_counter, :to => :sequence_state

  # Where we are in the condition flow (prologue, body, epilogue)
  delegate :where, :to => :sequence_state

  # Subcounter of where we are within the prologue/body/etc.
  delegate :subcounter, :to => :sequence_state
  
  # Form chat group ("channel") name from tasks associated with this group
  def self.chat_group_name_from_tasks(tasks)
    tasks.map(&:id).sort.map(&:to_s).join(',')
  end

  # Given a chat group channel name (string), return numeric index (0, 1, ...)
  # of which learner is represented by THIS task.
  def learner_index
    group_tasks.index(self.id.to_i) ||
      raise(LearnerNotInGroupError,
      "Chat group #{chat_group} does not include task id #{self.id}")
  end

  # Retrieve user state for all tasks in my chat group, including my state
  def user_state_for_all
    begin
      group_tasks.map { |task_id| Task.find(task_id).user_state }
    rescue ActiveRecord::RecordNotFound => e
      raise LearnerNotInGroupError, "Can't find user state for task: #{e.message}"
    end
  end

  def self.parse_group_tasks(group_tasks)
    group_tasks.to_s.split(',').map(&:to_i)
  end

  def group_tasks # :nodoc:
    case chat_group
    when blank?
      raise LearnerNotInGroupError, "Learner was never assigned to a group"
    when WaitingRoom::CHAT_GROUP_NONE
      raise LearnerNotInGroupError, "Learner was kicked out of Waiting Room"
    else
      Task.parse_group_tasks(chat_group)
    end
  end

  # Returns the +Template+ object that should be rendered for the
  # current page in the task sequence.
  def current_page
    page = sequence_state.current_page(self.condition)
    # the above call may modify sequence_state's internal state,
    # so we have to save the task to serialize it
    save!
    page
  end

  # Advance to the next page of the task.  Returns that page, or +nil+
  # if end of task has been reached.
  def next_page!
    sequence_state.next_page
    save!
    self.reload.current_page
  end

  # Advance to next question
  def next_question!
    sequence_state.next_question
    save!
    reload
  end

  def remove_from_chat_group(task_id)
    chat_group_ids = self.group_tasks
    if chat_group_ids.include? task_id   # Ignore if already removed
      chat_group_ids.delete(task_id)
      chat_group = chat_group_ids.map { |task_id| Task.find(task_id) }
      new_group_name = Task.chat_group_name_from_tasks(chat_group)
      self.assign_to_chat_group(new_group_name, false)
    end
  end

  # Assign this task to a particular chat group.  As a side effect, this removes the task
  # from its waiting room.
  def assign_to_chat_group(group, original_assignment)
    self.chat_group = group
    if original_assignment then self.original_chat_group = self.chat_group end
    self.waiting_room = nil
    self.save!
  end

  # Returns the next question to be consumed for the task.
  def current_question
    condition.primary_activity_schema.questions[question_counter]
  end

  # Log an interesting event related to this task. Denormalize the various
  # foreign key fields - see README.rdoc for details.  Some event names
  # require a value; enforcing that is left to the +EventLog+ validations.
  def log(name, value='')
    EventLog.create!(
      :name => name.to_sym,
      :value => value,
      :task => self,
      :learner => self.learner,
      :activity_schema => self.condition.primary_activity_schema,
      :condition => self.condition,
      :counter => self.counter,
      :subcounter => self.subcounter,
      :question_counter => self.question_counter,
      :question => self.current_question,
      :chat_group => self.chat_group)
  end

end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController

  before_filter :check_if_test_user, :except => [:create, :create_turk, :static]
  skip_before_filter :require_authenticated_user

  protected

  def check_if_test_user
    @task = Task.find params[:id]
    @test_user = @task.learner.for_testing?
  end

  public

  def static
    # creates an anonymous form to fill in params that will be used in task#create
  end

  def create
    self.create_from_params(params.merge(:turk_params => nil))
  end

  def create_turk
    if params[:assignmentId]=='ASSIGNMENT_ID_NOT_AVAILABLE'
      render "turk_preview"
    else
      self.create_from_params({:condition_id => params[:condition_id],
                               :learner_name => 'Turk worker ' + params[:workerId],
                               :turk_params => params})
    end
  end

  def create_from_params(params)
    learner = User.find_by_name(params[:learner_name])
    if learner and not learner.for_testing and Task.where(["chat_group IS NOT NULL AND learner_id=?", learner.id]).present?
      render "already_completed_task"
      return
    end

    begin
      @task = Task.create_from_params(params)
      @timer = session[:timer] = WaitingRoom.add(@task)
      @task.log(:start)
      redirect_to task_welcome_path(@task)
    rescue ActiveRecord::RecordNotFound => error
      Rails.logger.error error
      redirect_to(task_error_path, :alert => "The activity you tried to start couldn't be found.")
    rescue Task::ActivityNotOpenError
      redirect_to task_error_path, :alert => "This activity isn't open yet."
    end
  end

  #
  #  All methods below this point rely on the before_filter to set up @task
  #
  def welcome
    # Consider initial welcome page request to also be a heartbeat
    # This deals with an edge case where someone arrives at the last moment and
    # transitions to the next page before they can send a heartbeat message.
    @task.last_heartbeat = Time.zone.now

    unless (@timer = session[:timer])
      redirect_to :action => 'sorry', :notice => 'Timer value was not found.'
    end
    @heartbeat_seconds = WaitingRoom.heartbeat_seconds
    # never start with a timer of zero. If timer is zero, bump up to
    # next start time.
    if @timer.zero? then @timer += @task.condition.primary_activity_schema.starts_every end
  end

  def force_continue
    if @test_user
      @task.force_group_formation_now!
      session[:timer] = 0
    end
    redirect_to task_welcome_path(@task)
  end

  def join_group
    @task.last_heartbeat = Time.zone.now # Consider join_group request to also be a heartbeat
    @task.save!
    
    WaitingRoom.process_all!
    case @task.chat_group
    when WaitingRoom::CHAT_GROUP_NONE
      @task.log :reject
      render :action => 'sorry'
    when nil
      # WaitingRoom didn't get emptied.  Wait a few seconds and try again.
      # :BUG: this should be logged
      session[:timer] = 5
      render :action => 'welcome'
      else
      current_time = Time.now
      @task.update_attribute(:start_page_time, current_time)    #set the time the learner started the activity
      @task.log :form_group
      @task.save!
      redirect_to task_page_path(@task)
    end
  end
  
  def page
    @task_id = params[:id]
    @template = @task.current_page
    if @task.start_page_time
      @offset = (Time.now - @task.start_page_time).to_i
    else
      @offset = 0
    end

    if @template.nil?
      redirect_to('/', :notice => 'No more pages left in task')
    end
    # set up variables for template to consume
    @question = @task.current_question
    @question_counter = @task.question_counter
    @counter = @task.counter
    @subcounter = @task.subcounter
    @chat_group = @task.chat_group
    @start_form_tag = view_context.form_tag(task_next_page_path(@task),
      'id' => '_main', 'data-log-url' => task_collect_response_path(@task))
    @submit_to = task_next_page_path @task
    @me = @task.learner_index
    @data = @task.user_state_for_all
    @turk_params = @task.turk_params
    @u = @data[@me] || {}
    # HTML text that will be injected into generic uber-template
    @html = @template.html
    @task.log :view_page
    render :inline => @html, :layout => false
  end

  # user clicks submit => AJAX form submission posts to collect_response,
  # which records and timestamps answer WITHOUT advancing task counters

  def collect_response
    render(:nothing => true, :status => 403) and return unless request.xhr?
    # save any user state posted by template; if none provided, don't overwrite
    if params[:u]
      user_state = params[:u].stringify_keys
      @task.update_attribute(:user_state, user_state)
      user_state.each_pair do |key,val|
        @task.log(:user_state, "#{key}=#{val}")
      end
    end
    render :nothing => true
  end

  # timeout => directly post the form to next_page, which ONLY
  # advances the counters

  def next_page
    @task.next_page!
    # if 'next_question' field is nonblank, advance question counter
    @task.next_question! if !params[:next_question].blank?
    if @task.current_page
      current_time = Time.now
      @task.update_attribute(:start_page_time, current_time)    #set the time the learner started the activity
      # log the event of user 'continuing'
      @task.log(:continue)
      redirect_to task_page_path(@task)
    else
      @task.log :finish
      redirect_to '/'
    end
  end

  def log
    render(:nothing => true, :status => 403) and return unless request.xhr?
    # Log the event
    @task.log params[:name], params[:value]
    render :nothing => true
  end

  def error

  end

  def disconnect
    render(:nothing => true, :status => 403) and return unless request.xhr?
    task_id = params[:id].to_i
    @task.group_tasks.each { |t| Task.find(t).remove_from_chat_group task_id }
    render :nothing => true
  end

  def heartbeat
    render(:nothing => true, :status => 403) and return unless request.xhr?
    @task.last_heartbeat = Time.zone.now
    @task.save!
    render :nothing => true
  end
end

app/helpers/task_helper.rb
# Helper that creates a chat-text box

module TaskHelper
  # Produce a chat box widget which will eventually be what determines whether or not a websocket is instantiated
  # form on the page when it expires.
  # The helper emits a +<span>+ with +id="_chat_"+;
  # its *presence on the page* causes a  
  # websocket to be created.  See +chatpage.js.erb+ for the chat code.
  # Only one chat per view is allowed.
  #
  def vote
    if defined? __vote
      raise "Can only have a single vote per page"
    else
      __vote = true
    end
    render :partial => "tasks/vote"
  end

  def time_filler(condition)
    if defined? __time_filler
      raise "Can only have a single timer_filler per page"
    elsif condition.time_filler == nil or condition.time_filler.questions.length < 1
      return #raise "pass in proper questions"
    else
      __time_filler = true
      @questions = condition.time_filler.questions
    end
    render :partial => "tasks/time_filler"
  end

end

app/views/tasks/_force_continue_button.html.erb
<%= form_tag(task_force_continue_path(@task)) do %>
  <input type="submit" id="force_continue" class="btn btn-danger" value="Form Groups Immediately">
<% end %>

app/views/tasks/_time_filler.html.erb
<div id="this-carousel-id" class="carousel slide" data-interval="false"><!-- class of slide for animation -->
  <div class="carousel-inner">
    <div class="item active first">
      <h1>The activity will begin when the timer expires. Practice questions are available while you wait.</h1>
      <h3>press the Next button in the top right corner to begin.</h3>
    </div>
    <% @questions.each_with_index do |question, index| %>
      <div class="item">
        <div class="col-md-12 moocchat-left-panel">
          <div class="row">
            <div class="col-md-12 moocchat-left-panel-direction h3">
              For the essay below, select one of the <%= question.answers.size %> choices.
            </div>
          </div>
          <div class="row">
            <div class="col-md-12 moocchat-reading well"><%= question.text %></div>
          </div>
          <% correct = question.correct_answer_index %>
          <% str = index_to_letter(correct) %>
          <div class="row">
            <div id="timer_filler_answer" class="col-md-7 answer"><h4>The answer is</h4>
              <h4><%= str %></h4>
            </div>
          </div>
          <div class="row answer-box-js">
            <p>Select the best answer:</p>
            <!-- capture learner's answer as a letter A, B, C, ... -->
            <% question.answers.each_with_index do |answer, index| %>
            <% choice_letter = index_to_letter(index) %>
            <div class="col-md-12 moocchat-choice-area moocchat-conditional answer-box">
              <div class="llist-group-item active moocchat-probing-question-choice answer-box1">
                <div class="list-group-item moocchat-choice moocchat-choice-<%= index -%> answer-box">
                  <%= radio_button_tag "u[choice]", choice_letter, checked=false, :class => 'choice-button', 'data-index' => index %>
                  <div class="moocchat-choice-box moocchat-choice-box-<%= index -%> letter-box letter-box-<%= index -%>">
                    <%= choice_letter -%>
                  </div>
                  <label for="u_choice_<%= choice_letter -%>" class="list-group-item-heading moocchat-choice-statement">
                    <%= answer %> 
                  </label>
                </div>
              </div>
            </div>
            <% end %>
          </div>
        </div>
      </div>
    <% end %>
    <button id="time_filler_submit" class="btn btn-lg btn-primary">Submit Answer</button>
  </div><!-- /.carousel-inner -->
  <!--  Next and Previous controls below
        href values must reference the id for this carousel -->
    <a id="carousel_prev" class="carousel-control left" href="#this-carousel-id" data-slide="prev">&lsaquo;</a>
    <a id="carousel_next" class="carousel-control right" href="#this-carousel-id" data-slide="next">&rsaquo; Next</a>
</div><!-- /.carousel -->

app/views/tasks/_vote.html.erb
<div id="vote-box" data-chatgroup="<%= @chat_group ||= 'default' %>" data-taskid = "<%=@task_id%>" data-production = <%=Rails.env%>>
  <button id="vote-button" class="col-sm-6 col-sm-offset-1 btn btn-lg moocchat-next-button btn-danger">Request to End Chat</button>
</div>

app/views/tasks/already_completed_task.html.erb
<p class="sorry">
  Sorry, you have already attempted or completed this activity.
  <br>
  You may not attempt this activity more than once.
</p>

app/views/tasks/error.html.erb
<div class="error">
  <%= flash[:alert] %>
</div>

app/views/tasks/sorry.html.erb
<p class="sorry">
  Sorry, we were not able to find other learners for you to work with.
  <br>
  Please try this activity again later.
</p>

app/views/tasks/static.html.erb
<div class= "container">
  <center><h1 class="title"><strong>MoocChat Configuration Page</strong></h1></center>
  <br><br>
  <i><h4>Please fill out the following</h4></i>
  <%= form_tag tasks_path , :class => 'form-warning' do  %>
  <div class="field">
    <label for="learner_name"><b>Learner name</b></label><br/>
    <%= text_field_tag :learner_name,nil, :placeholder=> "Put Your Name Here" %>
  </div>
  <div class="field">
    <label for="condition_id"><b>Condition</b></label><br/>
    <%= collection_select( :condition, :id, Condition.all, :id, :name,
        {prompt: 'Please Select from the following choices'}, 
        {class: "form-control", name: "condition_id"}  ) %>
  </div>
  <br><br>
  <div class="actions">
    <%= submit_tag "SUBMIT" , :class => "btn btn-primary"%>
  </div>
<% end %>

app/views/tasks/turk_preview.html.erb
<img src="<%= asset_path 'moocchat_screenshot.png' %>" width="500"/>

app/views/tasks/welcome.html.erb
<h1>Welcome to MOOCchat</h1>
<h3> Greetings, <%= @task.learner.name %>!</h3>
<%= render(:partial => 'tasks/force_continue_button') if @test_user %>
<%= form_tag task_join_group_path(@task), :id => '_main' do %>
  <p> 
    Your activity <strong>"<%= @task.condition.primary_activity_schema.name %>"</strong>
    will start automatically in: 
    <span class="timer">
      <%= timer(@timer, {:heartbeat_seconds => @heartbeat_seconds, :heartbeat_url => '/tasks/' + @task.id.to_s + '/heartbeat'}) %>
    </span>
  </p>
  <%= time_filler(@task.condition)%>
  <input type="submit" id="_submit" class="offscreen">
<% end %>